// Code generated by ent, DO NOT EDIT.

package ent

import (
	"fmt"
	"strings"
	"time"
	"wechat-api/ent/messagerecords"

	"entgo.io/ent"
	"entgo.io/ent/dialect/sql"
)

// MessageRecords is the model entity for the MessageRecords schema.
type MessageRecords struct {
	config `json:"-"`
	// ID of the ent.
	ID uint64 `json:"id,omitempty"`
	// Create Time | 创建日期
	CreatedAt time.Time `json:"created_at,omitempty"`
	// Update Time | 修改日期
	UpdatedAt time.Time `json:"updated_at,omitempty"`
	// Status 1: normal 2: ban | 状态 1 正常 2 禁用
	Status uint8 `json:"status,omitempty"`
	// Delete Time | 删除日期
	DeletedAt time.Time `json:"deleted_at,omitempty"`
	// 机器人微信 id
	BotWxid string `json:"bot_wxid,omitempty"`
	// 联系人 id
	ContactID int `json:"contact_id,omitempty"`
	// 类型：1好友，2群组，3企业微信联系人
	ContactType int `json:"contact_type,omitempty"`
	// 接收方微信 id
	ContactWxid string `json:"contact_wxid,omitempty"`
	// 内容类型 1 文本 2 文件
	ContentType int `json:"content_type,omitempty"`
	// 发送内容
	Content string `json:"content,omitempty"`
	// 异常原因
	ErrorDetail string `json:"error_detail,omitempty"`
	// 发送时间
	SendTime time.Time `json:"send_time,omitempty"`
	// 源类型 1 点发 2 群发 3 SOP
	SourceType int `json:"source_type,omitempty"`
	// 源 ID
	SourceID int `json:"source_id,omitempty"`
	// 次源 ID
	SubSourceID  int `json:"sub_source_id,omitempty"`
	selectValues sql.SelectValues
}

// scanValues returns the types for scanning values from sql.Rows.
func (*MessageRecords) scanValues(columns []string) ([]any, error) {
	values := make([]any, len(columns))
	for i := range columns {
		switch columns[i] {
		case messagerecords.FieldID, messagerecords.FieldStatus, messagerecords.FieldContactID, messagerecords.FieldContactType, messagerecords.FieldContentType, messagerecords.FieldSourceType, messagerecords.FieldSourceID, messagerecords.FieldSubSourceID:
			values[i] = new(sql.NullInt64)
		case messagerecords.FieldBotWxid, messagerecords.FieldContactWxid, messagerecords.FieldContent, messagerecords.FieldErrorDetail:
			values[i] = new(sql.NullString)
		case messagerecords.FieldCreatedAt, messagerecords.FieldUpdatedAt, messagerecords.FieldDeletedAt, messagerecords.FieldSendTime:
			values[i] = new(sql.NullTime)
		default:
			values[i] = new(sql.UnknownType)
		}
	}
	return values, nil
}

// assignValues assigns the values that were returned from sql.Rows (after scanning)
// to the MessageRecords fields.
func (mr *MessageRecords) assignValues(columns []string, values []any) error {
	if m, n := len(values), len(columns); m < n {
		return fmt.Errorf("mismatch number of scan values: %d != %d", m, n)
	}
	for i := range columns {
		switch columns[i] {
		case messagerecords.FieldID:
			value, ok := values[i].(*sql.NullInt64)
			if !ok {
				return fmt.Errorf("unexpected type %T for field id", value)
			}
			mr.ID = uint64(value.Int64)
		case messagerecords.FieldCreatedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field created_at", values[i])
			} else if value.Valid {
				mr.CreatedAt = value.Time
			}
		case messagerecords.FieldUpdatedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field updated_at", values[i])
			} else if value.Valid {
				mr.UpdatedAt = value.Time
			}
		case messagerecords.FieldStatus:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field status", values[i])
			} else if value.Valid {
				mr.Status = uint8(value.Int64)
			}
		case messagerecords.FieldDeletedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field deleted_at", values[i])
			} else if value.Valid {
				mr.DeletedAt = value.Time
			}
		case messagerecords.FieldBotWxid:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field bot_wxid", values[i])
			} else if value.Valid {
				mr.BotWxid = value.String
			}
		case messagerecords.FieldContactID:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field contact_id", values[i])
			} else if value.Valid {
				mr.ContactID = int(value.Int64)
			}
		case messagerecords.FieldContactType:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field contact_type", values[i])
			} else if value.Valid {
				mr.ContactType = int(value.Int64)
			}
		case messagerecords.FieldContactWxid:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field contact_wxid", values[i])
			} else if value.Valid {
				mr.ContactWxid = value.String
			}
		case messagerecords.FieldContentType:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field content_type", values[i])
			} else if value.Valid {
				mr.ContentType = int(value.Int64)
			}
		case messagerecords.FieldContent:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field content", values[i])
			} else if value.Valid {
				mr.Content = value.String
			}
		case messagerecords.FieldErrorDetail:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field error_detail", values[i])
			} else if value.Valid {
				mr.ErrorDetail = value.String
			}
		case messagerecords.FieldSendTime:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field send_time", values[i])
			} else if value.Valid {
				mr.SendTime = value.Time
			}
		case messagerecords.FieldSourceType:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field source_type", values[i])
			} else if value.Valid {
				mr.SourceType = int(value.Int64)
			}
		case messagerecords.FieldSourceID:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field source_id", values[i])
			} else if value.Valid {
				mr.SourceID = int(value.Int64)
			}
		case messagerecords.FieldSubSourceID:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for field sub_source_id", values[i])
			} else if value.Valid {
				mr.SubSourceID = int(value.Int64)
			}
		default:
			mr.selectValues.Set(columns[i], values[i])
		}
	}
	return nil
}

// Value returns the ent.Value that was dynamically selected and assigned to the MessageRecords.
// This includes values selected through modifiers, order, etc.
func (mr *MessageRecords) Value(name string) (ent.Value, error) {
	return mr.selectValues.Get(name)
}

// Update returns a builder for updating this MessageRecords.
// Note that you need to call MessageRecords.Unwrap() before calling this method if this MessageRecords
// was returned from a transaction, and the transaction was committed or rolled back.
func (mr *MessageRecords) Update() *MessageRecordsUpdateOne {
	return NewMessageRecordsClient(mr.config).UpdateOne(mr)
}

// Unwrap unwraps the MessageRecords entity that was returned from a transaction after it was closed,
// so that all future queries will be executed through the driver which created the transaction.
func (mr *MessageRecords) Unwrap() *MessageRecords {
	_tx, ok := mr.config.driver.(*txDriver)
	if !ok {
		panic("ent: MessageRecords is not a transactional entity")
	}
	mr.config.driver = _tx.drv
	return mr
}

// String implements the fmt.Stringer.
func (mr *MessageRecords) String() string {
	var builder strings.Builder
	builder.WriteString("MessageRecords(")
	builder.WriteString(fmt.Sprintf("id=%v, ", mr.ID))
	builder.WriteString("created_at=")
	builder.WriteString(mr.CreatedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("updated_at=")
	builder.WriteString(mr.UpdatedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("status=")
	builder.WriteString(fmt.Sprintf("%v", mr.Status))
	builder.WriteString(", ")
	builder.WriteString("deleted_at=")
	builder.WriteString(mr.DeletedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("bot_wxid=")
	builder.WriteString(mr.BotWxid)
	builder.WriteString(", ")
	builder.WriteString("contact_id=")
	builder.WriteString(fmt.Sprintf("%v", mr.ContactID))
	builder.WriteString(", ")
	builder.WriteString("contact_type=")
	builder.WriteString(fmt.Sprintf("%v", mr.ContactType))
	builder.WriteString(", ")
	builder.WriteString("contact_wxid=")
	builder.WriteString(mr.ContactWxid)
	builder.WriteString(", ")
	builder.WriteString("content_type=")
	builder.WriteString(fmt.Sprintf("%v", mr.ContentType))
	builder.WriteString(", ")
	builder.WriteString("content=")
	builder.WriteString(mr.Content)
	builder.WriteString(", ")
	builder.WriteString("error_detail=")
	builder.WriteString(mr.ErrorDetail)
	builder.WriteString(", ")
	builder.WriteString("send_time=")
	builder.WriteString(mr.SendTime.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("source_type=")
	builder.WriteString(fmt.Sprintf("%v", mr.SourceType))
	builder.WriteString(", ")
	builder.WriteString("source_id=")
	builder.WriteString(fmt.Sprintf("%v", mr.SourceID))
	builder.WriteString(", ")
	builder.WriteString("sub_source_id=")
	builder.WriteString(fmt.Sprintf("%v", mr.SubSourceID))
	builder.WriteByte(')')
	return builder.String()
}

// MessageRecordsSlice is a parsable slice of MessageRecords.
type MessageRecordsSlice []*MessageRecords
