// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"
	"wechat-api/ent/messagerecords"
	"wechat-api/ent/predicate"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// MessageRecordsUpdate is the builder for updating MessageRecords entities.
type MessageRecordsUpdate struct {
	config
	hooks    []Hook
	mutation *MessageRecordsMutation
}

// Where appends a list predicates to the MessageRecordsUpdate builder.
func (mru *MessageRecordsUpdate) Where(ps ...predicate.MessageRecords) *MessageRecordsUpdate {
	mru.mutation.Where(ps...)
	return mru
}

// SetUpdatedAt sets the "updated_at" field.
func (mru *MessageRecordsUpdate) SetUpdatedAt(t time.Time) *MessageRecordsUpdate {
	mru.mutation.SetUpdatedAt(t)
	return mru
}

// SetStatus sets the "status" field.
func (mru *MessageRecordsUpdate) SetStatus(u uint8) *MessageRecordsUpdate {
	mru.mutation.ResetStatus()
	mru.mutation.SetStatus(u)
	return mru
}

// SetNillableStatus sets the "status" field if the given value is not nil.
func (mru *MessageRecordsUpdate) SetNillableStatus(u *uint8) *MessageRecordsUpdate {
	if u != nil {
		mru.SetStatus(*u)
	}
	return mru
}

// AddStatus adds u to the "status" field.
func (mru *MessageRecordsUpdate) AddStatus(u int8) *MessageRecordsUpdate {
	mru.mutation.AddStatus(u)
	return mru
}

// ClearStatus clears the value of the "status" field.
func (mru *MessageRecordsUpdate) ClearStatus() *MessageRecordsUpdate {
	mru.mutation.ClearStatus()
	return mru
}

// SetDeletedAt sets the "deleted_at" field.
func (mru *MessageRecordsUpdate) SetDeletedAt(t time.Time) *MessageRecordsUpdate {
	mru.mutation.SetDeletedAt(t)
	return mru
}

// SetNillableDeletedAt sets the "deleted_at" field if the given value is not nil.
func (mru *MessageRecordsUpdate) SetNillableDeletedAt(t *time.Time) *MessageRecordsUpdate {
	if t != nil {
		mru.SetDeletedAt(*t)
	}
	return mru
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (mru *MessageRecordsUpdate) ClearDeletedAt() *MessageRecordsUpdate {
	mru.mutation.ClearDeletedAt()
	return mru
}

// SetBotWxid sets the "bot_wxid" field.
func (mru *MessageRecordsUpdate) SetBotWxid(s string) *MessageRecordsUpdate {
	mru.mutation.SetBotWxid(s)
	return mru
}

// SetNillableBotWxid sets the "bot_wxid" field if the given value is not nil.
func (mru *MessageRecordsUpdate) SetNillableBotWxid(s *string) *MessageRecordsUpdate {
	if s != nil {
		mru.SetBotWxid(*s)
	}
	return mru
}

// SetContactID sets the "contact_id" field.
func (mru *MessageRecordsUpdate) SetContactID(i int) *MessageRecordsUpdate {
	mru.mutation.ResetContactID()
	mru.mutation.SetContactID(i)
	return mru
}

// SetNillableContactID sets the "contact_id" field if the given value is not nil.
func (mru *MessageRecordsUpdate) SetNillableContactID(i *int) *MessageRecordsUpdate {
	if i != nil {
		mru.SetContactID(*i)
	}
	return mru
}

// AddContactID adds i to the "contact_id" field.
func (mru *MessageRecordsUpdate) AddContactID(i int) *MessageRecordsUpdate {
	mru.mutation.AddContactID(i)
	return mru
}

// SetContactType sets the "contact_type" field.
func (mru *MessageRecordsUpdate) SetContactType(i int) *MessageRecordsUpdate {
	mru.mutation.ResetContactType()
	mru.mutation.SetContactType(i)
	return mru
}

// SetNillableContactType sets the "contact_type" field if the given value is not nil.
func (mru *MessageRecordsUpdate) SetNillableContactType(i *int) *MessageRecordsUpdate {
	if i != nil {
		mru.SetContactType(*i)
	}
	return mru
}

// AddContactType adds i to the "contact_type" field.
func (mru *MessageRecordsUpdate) AddContactType(i int) *MessageRecordsUpdate {
	mru.mutation.AddContactType(i)
	return mru
}

// SetContactWxid sets the "contact_wxid" field.
func (mru *MessageRecordsUpdate) SetContactWxid(s string) *MessageRecordsUpdate {
	mru.mutation.SetContactWxid(s)
	return mru
}

// SetNillableContactWxid sets the "contact_wxid" field if the given value is not nil.
func (mru *MessageRecordsUpdate) SetNillableContactWxid(s *string) *MessageRecordsUpdate {
	if s != nil {
		mru.SetContactWxid(*s)
	}
	return mru
}

// SetContentType sets the "content_type" field.
func (mru *MessageRecordsUpdate) SetContentType(i int) *MessageRecordsUpdate {
	mru.mutation.ResetContentType()
	mru.mutation.SetContentType(i)
	return mru
}

// SetNillableContentType sets the "content_type" field if the given value is not nil.
func (mru *MessageRecordsUpdate) SetNillableContentType(i *int) *MessageRecordsUpdate {
	if i != nil {
		mru.SetContentType(*i)
	}
	return mru
}

// AddContentType adds i to the "content_type" field.
func (mru *MessageRecordsUpdate) AddContentType(i int) *MessageRecordsUpdate {
	mru.mutation.AddContentType(i)
	return mru
}

// SetContent sets the "content" field.
func (mru *MessageRecordsUpdate) SetContent(s string) *MessageRecordsUpdate {
	mru.mutation.SetContent(s)
	return mru
}

// SetNillableContent sets the "content" field if the given value is not nil.
func (mru *MessageRecordsUpdate) SetNillableContent(s *string) *MessageRecordsUpdate {
	if s != nil {
		mru.SetContent(*s)
	}
	return mru
}

// SetErrorDetail sets the "error_detail" field.
func (mru *MessageRecordsUpdate) SetErrorDetail(s string) *MessageRecordsUpdate {
	mru.mutation.SetErrorDetail(s)
	return mru
}

// SetNillableErrorDetail sets the "error_detail" field if the given value is not nil.
func (mru *MessageRecordsUpdate) SetNillableErrorDetail(s *string) *MessageRecordsUpdate {
	if s != nil {
		mru.SetErrorDetail(*s)
	}
	return mru
}

// SetSendTime sets the "send_time" field.
func (mru *MessageRecordsUpdate) SetSendTime(t time.Time) *MessageRecordsUpdate {
	mru.mutation.SetSendTime(t)
	return mru
}

// SetNillableSendTime sets the "send_time" field if the given value is not nil.
func (mru *MessageRecordsUpdate) SetNillableSendTime(t *time.Time) *MessageRecordsUpdate {
	if t != nil {
		mru.SetSendTime(*t)
	}
	return mru
}

// ClearSendTime clears the value of the "send_time" field.
func (mru *MessageRecordsUpdate) ClearSendTime() *MessageRecordsUpdate {
	mru.mutation.ClearSendTime()
	return mru
}

// SetSourceType sets the "source_type" field.
func (mru *MessageRecordsUpdate) SetSourceType(i int) *MessageRecordsUpdate {
	mru.mutation.ResetSourceType()
	mru.mutation.SetSourceType(i)
	return mru
}

// SetNillableSourceType sets the "source_type" field if the given value is not nil.
func (mru *MessageRecordsUpdate) SetNillableSourceType(i *int) *MessageRecordsUpdate {
	if i != nil {
		mru.SetSourceType(*i)
	}
	return mru
}

// AddSourceType adds i to the "source_type" field.
func (mru *MessageRecordsUpdate) AddSourceType(i int) *MessageRecordsUpdate {
	mru.mutation.AddSourceType(i)
	return mru
}

// SetSourceID sets the "source_id" field.
func (mru *MessageRecordsUpdate) SetSourceID(i int) *MessageRecordsUpdate {
	mru.mutation.ResetSourceID()
	mru.mutation.SetSourceID(i)
	return mru
}

// SetNillableSourceID sets the "source_id" field if the given value is not nil.
func (mru *MessageRecordsUpdate) SetNillableSourceID(i *int) *MessageRecordsUpdate {
	if i != nil {
		mru.SetSourceID(*i)
	}
	return mru
}

// AddSourceID adds i to the "source_id" field.
func (mru *MessageRecordsUpdate) AddSourceID(i int) *MessageRecordsUpdate {
	mru.mutation.AddSourceID(i)
	return mru
}

// SetSubSourceID sets the "sub_source_id" field.
func (mru *MessageRecordsUpdate) SetSubSourceID(i int) *MessageRecordsUpdate {
	mru.mutation.ResetSubSourceID()
	mru.mutation.SetSubSourceID(i)
	return mru
}

// SetNillableSubSourceID sets the "sub_source_id" field if the given value is not nil.
func (mru *MessageRecordsUpdate) SetNillableSubSourceID(i *int) *MessageRecordsUpdate {
	if i != nil {
		mru.SetSubSourceID(*i)
	}
	return mru
}

// AddSubSourceID adds i to the "sub_source_id" field.
func (mru *MessageRecordsUpdate) AddSubSourceID(i int) *MessageRecordsUpdate {
	mru.mutation.AddSubSourceID(i)
	return mru
}

// Mutation returns the MessageRecordsMutation object of the builder.
func (mru *MessageRecordsUpdate) Mutation() *MessageRecordsMutation {
	return mru.mutation
}

// Save executes the query and returns the number of nodes affected by the update operation.
func (mru *MessageRecordsUpdate) Save(ctx context.Context) (int, error) {
	if err := mru.defaults(); err != nil {
		return 0, err
	}
	return withHooks(ctx, mru.sqlSave, mru.mutation, mru.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (mru *MessageRecordsUpdate) SaveX(ctx context.Context) int {
	affected, err := mru.Save(ctx)
	if err != nil {
		panic(err)
	}
	return affected
}

// Exec executes the query.
func (mru *MessageRecordsUpdate) Exec(ctx context.Context) error {
	_, err := mru.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (mru *MessageRecordsUpdate) ExecX(ctx context.Context) {
	if err := mru.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (mru *MessageRecordsUpdate) defaults() error {
	if _, ok := mru.mutation.UpdatedAt(); !ok {
		if messagerecords.UpdateDefaultUpdatedAt == nil {
			return fmt.Errorf("ent: uninitialized messagerecords.UpdateDefaultUpdatedAt (forgotten import ent/runtime?)")
		}
		v := messagerecords.UpdateDefaultUpdatedAt()
		mru.mutation.SetUpdatedAt(v)
	}
	return nil
}

func (mru *MessageRecordsUpdate) sqlSave(ctx context.Context) (n int, err error) {
	_spec := sqlgraph.NewUpdateSpec(messagerecords.Table, messagerecords.Columns, sqlgraph.NewFieldSpec(messagerecords.FieldID, field.TypeUint64))
	if ps := mru.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := mru.mutation.UpdatedAt(); ok {
		_spec.SetField(messagerecords.FieldUpdatedAt, field.TypeTime, value)
	}
	if value, ok := mru.mutation.Status(); ok {
		_spec.SetField(messagerecords.FieldStatus, field.TypeUint8, value)
	}
	if value, ok := mru.mutation.AddedStatus(); ok {
		_spec.AddField(messagerecords.FieldStatus, field.TypeUint8, value)
	}
	if mru.mutation.StatusCleared() {
		_spec.ClearField(messagerecords.FieldStatus, field.TypeUint8)
	}
	if value, ok := mru.mutation.DeletedAt(); ok {
		_spec.SetField(messagerecords.FieldDeletedAt, field.TypeTime, value)
	}
	if mru.mutation.DeletedAtCleared() {
		_spec.ClearField(messagerecords.FieldDeletedAt, field.TypeTime)
	}
	if value, ok := mru.mutation.BotWxid(); ok {
		_spec.SetField(messagerecords.FieldBotWxid, field.TypeString, value)
	}
	if value, ok := mru.mutation.ContactID(); ok {
		_spec.SetField(messagerecords.FieldContactID, field.TypeInt, value)
	}
	if value, ok := mru.mutation.AddedContactID(); ok {
		_spec.AddField(messagerecords.FieldContactID, field.TypeInt, value)
	}
	if value, ok := mru.mutation.ContactType(); ok {
		_spec.SetField(messagerecords.FieldContactType, field.TypeInt, value)
	}
	if value, ok := mru.mutation.AddedContactType(); ok {
		_spec.AddField(messagerecords.FieldContactType, field.TypeInt, value)
	}
	if value, ok := mru.mutation.ContactWxid(); ok {
		_spec.SetField(messagerecords.FieldContactWxid, field.TypeString, value)
	}
	if value, ok := mru.mutation.ContentType(); ok {
		_spec.SetField(messagerecords.FieldContentType, field.TypeInt, value)
	}
	if value, ok := mru.mutation.AddedContentType(); ok {
		_spec.AddField(messagerecords.FieldContentType, field.TypeInt, value)
	}
	if value, ok := mru.mutation.Content(); ok {
		_spec.SetField(messagerecords.FieldContent, field.TypeString, value)
	}
	if value, ok := mru.mutation.ErrorDetail(); ok {
		_spec.SetField(messagerecords.FieldErrorDetail, field.TypeString, value)
	}
	if value, ok := mru.mutation.SendTime(); ok {
		_spec.SetField(messagerecords.FieldSendTime, field.TypeTime, value)
	}
	if mru.mutation.SendTimeCleared() {
		_spec.ClearField(messagerecords.FieldSendTime, field.TypeTime)
	}
	if value, ok := mru.mutation.SourceType(); ok {
		_spec.SetField(messagerecords.FieldSourceType, field.TypeInt, value)
	}
	if value, ok := mru.mutation.AddedSourceType(); ok {
		_spec.AddField(messagerecords.FieldSourceType, field.TypeInt, value)
	}
	if value, ok := mru.mutation.SourceID(); ok {
		_spec.SetField(messagerecords.FieldSourceID, field.TypeInt, value)
	}
	if value, ok := mru.mutation.AddedSourceID(); ok {
		_spec.AddField(messagerecords.FieldSourceID, field.TypeInt, value)
	}
	if value, ok := mru.mutation.SubSourceID(); ok {
		_spec.SetField(messagerecords.FieldSubSourceID, field.TypeInt, value)
	}
	if value, ok := mru.mutation.AddedSubSourceID(); ok {
		_spec.AddField(messagerecords.FieldSubSourceID, field.TypeInt, value)
	}
	if n, err = sqlgraph.UpdateNodes(ctx, mru.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{messagerecords.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return 0, err
	}
	mru.mutation.done = true
	return n, nil
}

// MessageRecordsUpdateOne is the builder for updating a single MessageRecords entity.
type MessageRecordsUpdateOne struct {
	config
	fields   []string
	hooks    []Hook
	mutation *MessageRecordsMutation
}

// SetUpdatedAt sets the "updated_at" field.
func (mruo *MessageRecordsUpdateOne) SetUpdatedAt(t time.Time) *MessageRecordsUpdateOne {
	mruo.mutation.SetUpdatedAt(t)
	return mruo
}

// SetStatus sets the "status" field.
func (mruo *MessageRecordsUpdateOne) SetStatus(u uint8) *MessageRecordsUpdateOne {
	mruo.mutation.ResetStatus()
	mruo.mutation.SetStatus(u)
	return mruo
}

// SetNillableStatus sets the "status" field if the given value is not nil.
func (mruo *MessageRecordsUpdateOne) SetNillableStatus(u *uint8) *MessageRecordsUpdateOne {
	if u != nil {
		mruo.SetStatus(*u)
	}
	return mruo
}

// AddStatus adds u to the "status" field.
func (mruo *MessageRecordsUpdateOne) AddStatus(u int8) *MessageRecordsUpdateOne {
	mruo.mutation.AddStatus(u)
	return mruo
}

// ClearStatus clears the value of the "status" field.
func (mruo *MessageRecordsUpdateOne) ClearStatus() *MessageRecordsUpdateOne {
	mruo.mutation.ClearStatus()
	return mruo
}

// SetDeletedAt sets the "deleted_at" field.
func (mruo *MessageRecordsUpdateOne) SetDeletedAt(t time.Time) *MessageRecordsUpdateOne {
	mruo.mutation.SetDeletedAt(t)
	return mruo
}

// SetNillableDeletedAt sets the "deleted_at" field if the given value is not nil.
func (mruo *MessageRecordsUpdateOne) SetNillableDeletedAt(t *time.Time) *MessageRecordsUpdateOne {
	if t != nil {
		mruo.SetDeletedAt(*t)
	}
	return mruo
}

// ClearDeletedAt clears the value of the "deleted_at" field.
func (mruo *MessageRecordsUpdateOne) ClearDeletedAt() *MessageRecordsUpdateOne {
	mruo.mutation.ClearDeletedAt()
	return mruo
}

// SetBotWxid sets the "bot_wxid" field.
func (mruo *MessageRecordsUpdateOne) SetBotWxid(s string) *MessageRecordsUpdateOne {
	mruo.mutation.SetBotWxid(s)
	return mruo
}

// SetNillableBotWxid sets the "bot_wxid" field if the given value is not nil.
func (mruo *MessageRecordsUpdateOne) SetNillableBotWxid(s *string) *MessageRecordsUpdateOne {
	if s != nil {
		mruo.SetBotWxid(*s)
	}
	return mruo
}

// SetContactID sets the "contact_id" field.
func (mruo *MessageRecordsUpdateOne) SetContactID(i int) *MessageRecordsUpdateOne {
	mruo.mutation.ResetContactID()
	mruo.mutation.SetContactID(i)
	return mruo
}

// SetNillableContactID sets the "contact_id" field if the given value is not nil.
func (mruo *MessageRecordsUpdateOne) SetNillableContactID(i *int) *MessageRecordsUpdateOne {
	if i != nil {
		mruo.SetContactID(*i)
	}
	return mruo
}

// AddContactID adds i to the "contact_id" field.
func (mruo *MessageRecordsUpdateOne) AddContactID(i int) *MessageRecordsUpdateOne {
	mruo.mutation.AddContactID(i)
	return mruo
}

// SetContactType sets the "contact_type" field.
func (mruo *MessageRecordsUpdateOne) SetContactType(i int) *MessageRecordsUpdateOne {
	mruo.mutation.ResetContactType()
	mruo.mutation.SetContactType(i)
	return mruo
}

// SetNillableContactType sets the "contact_type" field if the given value is not nil.
func (mruo *MessageRecordsUpdateOne) SetNillableContactType(i *int) *MessageRecordsUpdateOne {
	if i != nil {
		mruo.SetContactType(*i)
	}
	return mruo
}

// AddContactType adds i to the "contact_type" field.
func (mruo *MessageRecordsUpdateOne) AddContactType(i int) *MessageRecordsUpdateOne {
	mruo.mutation.AddContactType(i)
	return mruo
}

// SetContactWxid sets the "contact_wxid" field.
func (mruo *MessageRecordsUpdateOne) SetContactWxid(s string) *MessageRecordsUpdateOne {
	mruo.mutation.SetContactWxid(s)
	return mruo
}

// SetNillableContactWxid sets the "contact_wxid" field if the given value is not nil.
func (mruo *MessageRecordsUpdateOne) SetNillableContactWxid(s *string) *MessageRecordsUpdateOne {
	if s != nil {
		mruo.SetContactWxid(*s)
	}
	return mruo
}

// SetContentType sets the "content_type" field.
func (mruo *MessageRecordsUpdateOne) SetContentType(i int) *MessageRecordsUpdateOne {
	mruo.mutation.ResetContentType()
	mruo.mutation.SetContentType(i)
	return mruo
}

// SetNillableContentType sets the "content_type" field if the given value is not nil.
func (mruo *MessageRecordsUpdateOne) SetNillableContentType(i *int) *MessageRecordsUpdateOne {
	if i != nil {
		mruo.SetContentType(*i)
	}
	return mruo
}

// AddContentType adds i to the "content_type" field.
func (mruo *MessageRecordsUpdateOne) AddContentType(i int) *MessageRecordsUpdateOne {
	mruo.mutation.AddContentType(i)
	return mruo
}

// SetContent sets the "content" field.
func (mruo *MessageRecordsUpdateOne) SetContent(s string) *MessageRecordsUpdateOne {
	mruo.mutation.SetContent(s)
	return mruo
}

// SetNillableContent sets the "content" field if the given value is not nil.
func (mruo *MessageRecordsUpdateOne) SetNillableContent(s *string) *MessageRecordsUpdateOne {
	if s != nil {
		mruo.SetContent(*s)
	}
	return mruo
}

// SetErrorDetail sets the "error_detail" field.
func (mruo *MessageRecordsUpdateOne) SetErrorDetail(s string) *MessageRecordsUpdateOne {
	mruo.mutation.SetErrorDetail(s)
	return mruo
}

// SetNillableErrorDetail sets the "error_detail" field if the given value is not nil.
func (mruo *MessageRecordsUpdateOne) SetNillableErrorDetail(s *string) *MessageRecordsUpdateOne {
	if s != nil {
		mruo.SetErrorDetail(*s)
	}
	return mruo
}

// SetSendTime sets the "send_time" field.
func (mruo *MessageRecordsUpdateOne) SetSendTime(t time.Time) *MessageRecordsUpdateOne {
	mruo.mutation.SetSendTime(t)
	return mruo
}

// SetNillableSendTime sets the "send_time" field if the given value is not nil.
func (mruo *MessageRecordsUpdateOne) SetNillableSendTime(t *time.Time) *MessageRecordsUpdateOne {
	if t != nil {
		mruo.SetSendTime(*t)
	}
	return mruo
}

// ClearSendTime clears the value of the "send_time" field.
func (mruo *MessageRecordsUpdateOne) ClearSendTime() *MessageRecordsUpdateOne {
	mruo.mutation.ClearSendTime()
	return mruo
}

// SetSourceType sets the "source_type" field.
func (mruo *MessageRecordsUpdateOne) SetSourceType(i int) *MessageRecordsUpdateOne {
	mruo.mutation.ResetSourceType()
	mruo.mutation.SetSourceType(i)
	return mruo
}

// SetNillableSourceType sets the "source_type" field if the given value is not nil.
func (mruo *MessageRecordsUpdateOne) SetNillableSourceType(i *int) *MessageRecordsUpdateOne {
	if i != nil {
		mruo.SetSourceType(*i)
	}
	return mruo
}

// AddSourceType adds i to the "source_type" field.
func (mruo *MessageRecordsUpdateOne) AddSourceType(i int) *MessageRecordsUpdateOne {
	mruo.mutation.AddSourceType(i)
	return mruo
}

// SetSourceID sets the "source_id" field.
func (mruo *MessageRecordsUpdateOne) SetSourceID(i int) *MessageRecordsUpdateOne {
	mruo.mutation.ResetSourceID()
	mruo.mutation.SetSourceID(i)
	return mruo
}

// SetNillableSourceID sets the "source_id" field if the given value is not nil.
func (mruo *MessageRecordsUpdateOne) SetNillableSourceID(i *int) *MessageRecordsUpdateOne {
	if i != nil {
		mruo.SetSourceID(*i)
	}
	return mruo
}

// AddSourceID adds i to the "source_id" field.
func (mruo *MessageRecordsUpdateOne) AddSourceID(i int) *MessageRecordsUpdateOne {
	mruo.mutation.AddSourceID(i)
	return mruo
}

// SetSubSourceID sets the "sub_source_id" field.
func (mruo *MessageRecordsUpdateOne) SetSubSourceID(i int) *MessageRecordsUpdateOne {
	mruo.mutation.ResetSubSourceID()
	mruo.mutation.SetSubSourceID(i)
	return mruo
}

// SetNillableSubSourceID sets the "sub_source_id" field if the given value is not nil.
func (mruo *MessageRecordsUpdateOne) SetNillableSubSourceID(i *int) *MessageRecordsUpdateOne {
	if i != nil {
		mruo.SetSubSourceID(*i)
	}
	return mruo
}

// AddSubSourceID adds i to the "sub_source_id" field.
func (mruo *MessageRecordsUpdateOne) AddSubSourceID(i int) *MessageRecordsUpdateOne {
	mruo.mutation.AddSubSourceID(i)
	return mruo
}

// Mutation returns the MessageRecordsMutation object of the builder.
func (mruo *MessageRecordsUpdateOne) Mutation() *MessageRecordsMutation {
	return mruo.mutation
}

// Where appends a list predicates to the MessageRecordsUpdate builder.
func (mruo *MessageRecordsUpdateOne) Where(ps ...predicate.MessageRecords) *MessageRecordsUpdateOne {
	mruo.mutation.Where(ps...)
	return mruo
}

// Select allows selecting one or more fields (columns) of the returned entity.
// The default is selecting all fields defined in the entity schema.
func (mruo *MessageRecordsUpdateOne) Select(field string, fields ...string) *MessageRecordsUpdateOne {
	mruo.fields = append([]string{field}, fields...)
	return mruo
}

// Save executes the query and returns the updated MessageRecords entity.
func (mruo *MessageRecordsUpdateOne) Save(ctx context.Context) (*MessageRecords, error) {
	if err := mruo.defaults(); err != nil {
		return nil, err
	}
	return withHooks(ctx, mruo.sqlSave, mruo.mutation, mruo.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (mruo *MessageRecordsUpdateOne) SaveX(ctx context.Context) *MessageRecords {
	node, err := mruo.Save(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// Exec executes the query on the entity.
func (mruo *MessageRecordsUpdateOne) Exec(ctx context.Context) error {
	_, err := mruo.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (mruo *MessageRecordsUpdateOne) ExecX(ctx context.Context) {
	if err := mruo.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (mruo *MessageRecordsUpdateOne) defaults() error {
	if _, ok := mruo.mutation.UpdatedAt(); !ok {
		if messagerecords.UpdateDefaultUpdatedAt == nil {
			return fmt.Errorf("ent: uninitialized messagerecords.UpdateDefaultUpdatedAt (forgotten import ent/runtime?)")
		}
		v := messagerecords.UpdateDefaultUpdatedAt()
		mruo.mutation.SetUpdatedAt(v)
	}
	return nil
}

func (mruo *MessageRecordsUpdateOne) sqlSave(ctx context.Context) (_node *MessageRecords, err error) {
	_spec := sqlgraph.NewUpdateSpec(messagerecords.Table, messagerecords.Columns, sqlgraph.NewFieldSpec(messagerecords.FieldID, field.TypeUint64))
	id, ok := mruo.mutation.ID()
	if !ok {
		return nil, &ValidationError{Name: "id", err: errors.New(`ent: missing "MessageRecords.id" for update`)}
	}
	_spec.Node.ID.Value = id
	if fields := mruo.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, messagerecords.FieldID)
		for _, f := range fields {
			if !messagerecords.ValidColumn(f) {
				return nil, &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
			}
			if f != messagerecords.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, f)
			}
		}
	}
	if ps := mruo.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := mruo.mutation.UpdatedAt(); ok {
		_spec.SetField(messagerecords.FieldUpdatedAt, field.TypeTime, value)
	}
	if value, ok := mruo.mutation.Status(); ok {
		_spec.SetField(messagerecords.FieldStatus, field.TypeUint8, value)
	}
	if value, ok := mruo.mutation.AddedStatus(); ok {
		_spec.AddField(messagerecords.FieldStatus, field.TypeUint8, value)
	}
	if mruo.mutation.StatusCleared() {
		_spec.ClearField(messagerecords.FieldStatus, field.TypeUint8)
	}
	if value, ok := mruo.mutation.DeletedAt(); ok {
		_spec.SetField(messagerecords.FieldDeletedAt, field.TypeTime, value)
	}
	if mruo.mutation.DeletedAtCleared() {
		_spec.ClearField(messagerecords.FieldDeletedAt, field.TypeTime)
	}
	if value, ok := mruo.mutation.BotWxid(); ok {
		_spec.SetField(messagerecords.FieldBotWxid, field.TypeString, value)
	}
	if value, ok := mruo.mutation.ContactID(); ok {
		_spec.SetField(messagerecords.FieldContactID, field.TypeInt, value)
	}
	if value, ok := mruo.mutation.AddedContactID(); ok {
		_spec.AddField(messagerecords.FieldContactID, field.TypeInt, value)
	}
	if value, ok := mruo.mutation.ContactType(); ok {
		_spec.SetField(messagerecords.FieldContactType, field.TypeInt, value)
	}
	if value, ok := mruo.mutation.AddedContactType(); ok {
		_spec.AddField(messagerecords.FieldContactType, field.TypeInt, value)
	}
	if value, ok := mruo.mutation.ContactWxid(); ok {
		_spec.SetField(messagerecords.FieldContactWxid, field.TypeString, value)
	}
	if value, ok := mruo.mutation.ContentType(); ok {
		_spec.SetField(messagerecords.FieldContentType, field.TypeInt, value)
	}
	if value, ok := mruo.mutation.AddedContentType(); ok {
		_spec.AddField(messagerecords.FieldContentType, field.TypeInt, value)
	}
	if value, ok := mruo.mutation.Content(); ok {
		_spec.SetField(messagerecords.FieldContent, field.TypeString, value)
	}
	if value, ok := mruo.mutation.ErrorDetail(); ok {
		_spec.SetField(messagerecords.FieldErrorDetail, field.TypeString, value)
	}
	if value, ok := mruo.mutation.SendTime(); ok {
		_spec.SetField(messagerecords.FieldSendTime, field.TypeTime, value)
	}
	if mruo.mutation.SendTimeCleared() {
		_spec.ClearField(messagerecords.FieldSendTime, field.TypeTime)
	}
	if value, ok := mruo.mutation.SourceType(); ok {
		_spec.SetField(messagerecords.FieldSourceType, field.TypeInt, value)
	}
	if value, ok := mruo.mutation.AddedSourceType(); ok {
		_spec.AddField(messagerecords.FieldSourceType, field.TypeInt, value)
	}
	if value, ok := mruo.mutation.SourceID(); ok {
		_spec.SetField(messagerecords.FieldSourceID, field.TypeInt, value)
	}
	if value, ok := mruo.mutation.AddedSourceID(); ok {
		_spec.AddField(messagerecords.FieldSourceID, field.TypeInt, value)
	}
	if value, ok := mruo.mutation.SubSourceID(); ok {
		_spec.SetField(messagerecords.FieldSubSourceID, field.TypeInt, value)
	}
	if value, ok := mruo.mutation.AddedSubSourceID(); ok {
		_spec.AddField(messagerecords.FieldSubSourceID, field.TypeInt, value)
	}
	_node = &MessageRecords{config: mruo.config}
	_spec.Assign = _node.assignValues
	_spec.ScanValues = _node.scanValues
	if err = sqlgraph.UpdateNode(ctx, mruo.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{messagerecords.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	mruo.mutation.done = true
	return _node, nil
}
